## ktorrent 5.2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(KTORRENT)

set (QT_MIN_VERSION "5.7.0")
set (KF5_MIN_VERSION "5.15")

find_package(ECM REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules/")

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(FeatureSummary)
include(GenerateExportHeader)
include(ECMInstallIcons)
include(ECMAddAppIcon)
include(ECMMarkAsTest)
include(ECMMarkNonGuiExecutable)

find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED
    Core
    DBus
    Network
    Script
    Widgets
)

find_package(KF5 ${KF5_MIN_VERSION} REQUIRED
  COMPONENTS
    Config
    ConfigWidgets
    CoreAddons
    Crash
    DBusAddons
    I18n
    IconThemes
    KIO
    Notifications
    NotifyConfig
    KCMUtils
    Parts
    Solid
    WidgetsAddons
    WindowSystem
    XmlGui
  OPTIONAL_COMPONENTS
    DocTools
)

find_package(KF5Torrent 2.2 CONFIG REQUIRED)
find_package(Boost REQUIRED)

find_package(KF5TextWidgets ${KF5_REQUIRED_VERSION})
set_package_properties(KF5TextWidgets
  PROPERTIES
  TYPE OPTIONAL
  PURPOSE "Required for KTorrent's IP Filter plugin"
)
if(KF5TextWidgets_FOUND)
  set(HAVE_KF5TextWidgets 1)
endif()

find_package(KF5Archive ${KF5_REQUIRED_VERSION})
set_package_properties(KF5Archive
  PROPERTIES
  TYPE OPTIONAL
  PURPOSE "Required for KTorrent's scripting plugin"
)
if(KF5Archive_FOUND)
  set(HAVE_KF5Archive 1)
endif()

find_package(KF5ItemViews ${KF5_REQUIRED_VERSION})
set_package_properties(KF5ItemViews
  PROPERTIES
  TYPE OPTIONAL
  PURPOSE "Required for KTorrent's scripting plugin"
)
if(KF5ItemViews_FOUND)
  set(HAVE_KF5ItemViews 1)
endif()

find_package(KF5Kross ${KF5_REQUIRED_VERSION})
set_package_properties(KF5Kross
  PROPERTIES
  TYPE OPTIONAL
  PURPOSE "Required for KTorrent's scripting plugin"
)
if(KF5Kross_FOUND)
  set(HAVE_KF5Kross 1)
endif()

find_package(KF5Plotting ${KF5_REQUIRED_VERSION})
set_package_properties(KF5Plotting
  PROPERTIES
  TYPE OPTIONAL
  PURPOSE "Required for KTorrent's statistics plugin"
)
if(KF5Plotting_FOUND)
  set(HAVE_KF5Plotting 1)
endif()

find_package(KF5Syndication)
set_package_properties(KF5Syndication
  PROPERTIES
  TYPE OPTIONAL
  PURPOSE "Required for KTorrent's syndication plugin"
)
if(KF5Syndication_FOUND)
  set(HAVE_KF5Syndication 1)
endif()

find_package(Qt5WebEngineWidgets ${QT_MIN_VERSION})
set_package_properties(Qt5WebEngineWidgets
  PROPERTIES
  TYPE OPTIONAL
  PURPOSE "Required for KTorrent's search and syndication plugins"
)
if(Qt5WebEngineWidgets_FOUND)
  set(HAVE_Qt5WebEngineWidgets 1)
endif()

find_package(KF5DNSSD ${KF5_REQUIRED_VERSION})
set_package_properties(KF5DNSSD
  PROPERTIES
  TYPE OPTIONAL
  PURPOSE "Required for KTorrent's Zeroconf plugin"
)
if(KF5DNSSD_FOUND)
  set(HAVE_KF5DNSSD 1)
endif()

find_package(KF5Completion ${KF5_REQUIRED_VERSION})
set_package_properties(KF5Completion
  PROPERTIES
  TYPE OPTIONAL
  PURPOSE "Required for KTorrent's UPnP plugin"
)
if(KF5Completion_FOUND)
  set(HAVE_KF5Completion 1)
endif()

find_package(LibKWorkspace CONFIG)
set_package_properties(LibKWorkspace
  PROPERTIES
  TYPE OPTIONAL
  PURPOSE "Required for KTorrent's shutdown plugin"
)
if(LibKWorkspace_FOUND)
  set(HAVE_LibKWorkspace 1)
endif()

find_package(Taglib)
if(TAGLIB_FOUND)
  set(HAVE_Taglib 1)
endif()
#find_package(Qt5 ${QT_MIN_VERSION} OPTIONAL_COMPONENTS Multimedia MultimediaWidgets)
find_package(Phonon4Qt5)
set_package_properties(Taglib
  PROPERTIES
  TYPE OPTIONAL
  PURPOSE "Required for KTorrent's multimedia plugin"
)
set_package_properties(Phonon4Qt5
  PROPERTIES
  TYPE OPTIONAL
  PURPOSE "Required for KTorrent's multimedia plugin"
)

#
# checks for functions and stuff
#
include(CheckIncludeFiles)
include(CheckFunctionExists)
include(CheckTypeSize) #XFS


# according to http://www.cmake.org/pipermail/cmake/2008-June/022381.html
kde_enable_exceptions()

add_definitions(
  -DQT_USE_QSTRINGBUILDER
  -DQT_NO_CAST_TO_ASCII
  -DQT_NO_CAST_FROM_ASCII
  -DQT_STRICT_ITERATORS
  -DQT_NO_URL_CAST_FROM_STRING
  -DQT_NO_CAST_FROM_BYTEARRAY
  -DQT_NO_CAST_TO_BYTEARRAY
#   -DQT_NO_SIGNALS_SLOTS_KEYWORDS
  -DQT_USE_FAST_OPERATOR_PLUS
)

set (KTORRENT_DBUS_XML_DIR ${KTORRENT_SOURCE_DIR}/dbus_xml)
set (KTORRENT_PLUGIN_INSTALL_DIR ${PLUGIN_INSTALL_DIR}/ktorrent)

include_directories(
   ${Boost_INCLUDE_DIR}
)

add_subdirectory(libktcore)
add_subdirectory(plugins)
add_subdirectory(ktorrent)
add_subdirectory(ktupnptest)
#add_subdirectory(plasma)
add_subdirectory(ktmagnetdownloader)
if (KF5DocTools_FOUND)
    add_subdirectory(doc)
endif()

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

find_package(KF5I18n CONFIG REQUIRED)
ki18n_install(po)

  find_package(KF5DocTools CONFIG)
  if(KF5DocTools_FOUND)
    kdoctools_install(po)
  endif()

=== ktmagnetdownloader/CMakeLists.txt ===
set(magnetdownloadtest_SRCS magnetdownloader.cpp magnettest.cpp)
add_executable(ktmagnetdownloader ${magnetdownloadtest_SRCS})
target_link_libraries(ktmagnetdownloader ktcore Qt5::Widgets Qt5::Network)
ecm_mark_nongui_executable(ktmagnetdownloader)
install(TARGETS ktmagnetdownloader ${INSTALL_TARGETS_DEFAULT_ARGS})

=== ktorrent/CMakeLists.txt ===
#  set(kt4_SRC app.cpp mainwindow.cpp core.cpp view.cpp viewmodel.cpp main.cpp)
set(ktorrent_SRC 
	main.cpp
	core.cpp
	gui.cpp
	torrentactivity.cpp
	statusbar.cpp
	trayicon.cpp
	ipfilterlist.cpp
	ipfilterwidget.cpp
	statusbarofflineindicator.cpp
	
	tools/queuemanagerwidget.cpp
	tools/queuemanagermodel.cpp
	tools/magnetmodel.cpp
	tools/magnetview.cpp
	
	groups/grouppolicydlg.cpp
	groups/groupfiltermodel.cpp
	groups/groupview.cpp
	groups/groupviewmodel.cpp
	groups/groupswitcher.cpp
	
	dialogs/pastedialog.cpp
	dialogs/speedlimitsdlg.cpp
	dialogs/speedlimitsmodel.cpp
	dialogs/spinboxdelegate.cpp
	dialogs/torrentcreatordlg.cpp
	dialogs/missingfilesdlg.cpp
	dialogs/importdialog.cpp
	dialogs/addpeersdlg.cpp
	dialogs/fileselectdlg.cpp 
	
	pref/prefdialog.cpp 
	pref/advancedpref.cpp
	pref/networkpref.cpp
	pref/proxypref.cpp
	pref/qmpref.cpp
	pref/generalpref.cpp
	pref/recommendedsettingsdlg.cpp
	pref/btpref.cpp
	
	view/view.cpp 
	view/viewmodel.cpp
	view/viewdelegate.cpp
	view/viewselectionmodel.cpp
	view/viewjobtracker.cpp 
	view/scanextender.cpp
	view/propertiesdlg.cpp
	view/torrentsearchbar.cpp 
)


ki18n_wrap_ui(ktorrent_SRC
	ipfilterwidget.ui 
	
	dialogs/speedlimitsdlg.ui 
	dialogs/pastedlgbase.ui 
	dialogs/torrentcreatordlg.ui 
	dialogs/missingfilesdlg.ui
	dialogs/importdialog.ui
	dialogs/addpeersdlg.ui
	dialogs/fileselectdlg.ui 
	
	groups/grouppolicydlg.ui
	
	pref/qmpref.ui 
	pref/btpref.ui
	pref/generalpref.ui 
	pref/advancedpref.ui 
	pref/networkpref.ui
	pref/proxypref.ui
	pref/recommendedsettingsdlg.ui
	
	view/scanextender.ui
	view/propertiesdlg.ui
)

set(powermanagementinhibit_xml ${KTORRENT_DBUS_XML_DIR}/org.freedesktop.PowerManagement.Inhibit.xml)
qt5_add_dbus_interface(ktorrent_SRC ${powermanagementinhibit_xml} powermanagementinhibit_interface)

# collect icons
set(KTORRENT_ICONS_PNG
    icons/16-apps-ktorrent.png
    icons/22-apps-ktorrent.png
    icons/32-apps-ktorrent.png
    icons/48-apps-ktorrent.png
    icons/64-apps-ktorrent.png
    icons/128-apps-ktorrent.png
)

ecm_add_app_icon(ktorrent_SRC ICONS ${KTORRENT_ICONS_PNG})

add_executable(ktorrent_app ${ktorrent_SRC})
set_property(TARGET ktorrent_app PROPERTY CXX_STANDARD 14)
set_target_properties(ktorrent_app  PROPERTIES OUTPUT_NAME ktorrent)

target_link_libraries(ktorrent_app
    ktcore
    KF5::Torrent
    KF5::Crash
    KF5::ConfigCore
    KF5::ConfigGui
    KF5::DBusAddons
    KF5::I18n
    KF5::IconThemes
    KF5::KIOCore
    KF5::KIOFileWidgets
    KF5::Notifications
    KF5::NotifyConfig
    KF5::Parts
    KF5::Solid
    KF5::WidgetsAddons
    KF5::WindowSystem
    KF5::XmlGui
    KF5::Crash
)

install(TARGETS ktorrent_app ${INSTALL_TARGETS_DEFAULT_ARGS})
install(PROGRAMS org.kde.ktorrent.desktop  DESTINATION  ${XDG_APPS_INSTALL_DIR} )
install(FILES ktorrentui.rc DESTINATION ${KXMLGUI_INSTALL_DIR}/ktorrent )
install(FILES kttorrentactivityui.rc DESTINATION ${KXMLGUI_INSTALL_DIR}/ktorrent )
install(FILES ktorrent.notifyrc DESTINATION ${KNOTIFYRC_INSTALL_DIR} )
install(FILES org.kde.ktorrent.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR} )

add_subdirectory(icons)

=== libktcore/CMakeLists.txt ===
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config-ktcore.h.cmake ${CMAKE_BINARY_DIR}/config-ktcore.h)

include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

set(libktorrent_SRC 
	util/mmapfile.cpp
	util/itemselectionmodel.cpp
	util/stringcompletionmodel.cpp
	util/treefiltermodel.cpp
	
	interfaces/functions.cpp
	interfaces/plugin.cpp
	interfaces/guiinterface.cpp
	interfaces/coreinterface.cpp
	interfaces/prefpageinterface.cpp
	interfaces/activity.cpp
	interfaces/torrentactivityinterface.cpp
	
	torrent/queuemanager.cpp
	torrent/magnetmanager.cpp
	torrent/torrentfilemodel.cpp
	torrent/torrentfiletreemodel.cpp
	torrent/torrentfilelistmodel.cpp
	torrent/chunkbar.cpp 
	torrent/chunkbarrenderer.cpp
	torrent/jobtracker.cpp
	torrent/jobprogresswidget.cpp 
	torrent/basicjobprogresswidget.cpp 
	
	groups/group.cpp
	groups/torrentgroup.cpp
	groups/allgroup.cpp
	groups/ungroupedgroup.cpp
	groups/groupmanager.cpp
	groups/functiongroup.cpp
	
	dbus/dbus.cpp
	dbus/dbustorrent.cpp
	dbus/dbusgroup.cpp
	dbus/dbussettings.cpp
	dbus/dbustorrentfilestream.cpp
	
	gui/centralwidget.cpp
	gui/tabbarwidget.cpp
	gui/extender.cpp
	
	plugin/pluginmanager.cpp
	plugin/pluginactivity.cpp

	ktorrent.kcfg
)

set(libktorrent_UI torrent/basicjobprogresswidget.ui )

ki18n_wrap_ui(libktorrent_SRC ${libktorrent_UI})
kconfig_add_kcfg_files(libktorrent_SRC settings.kcfgc)
add_library(ktcore ${libktorrent_SRC})
generate_export_header(ktcore BASE_NAME ktcore)

target_link_libraries(ktcore PUBLIC
    KF5::ConfigCore
    KF5::CoreAddons
    KF5::I18n
    KF5::KCMUtils
    KF5::Parts
    KF5::Solid
    KF5::Torrent
    KF5::XmlGui
)

target_include_directories(ktcore PUBLIC "$<BUILD_INTERFACE:${KTORRENT_SOURCE_DIR}/libktcore;${KTORRENT_BINARY_DIR}/libktcore;${KTORRENT_BINARY_DIR}>")

set_target_properties(ktcore PROPERTIES VERSION 16.0.0 SOVERSION 16 )
install(TARGETS ktcore  ${INSTALL_TARGETS_DEFAULT_ARGS} LIBRARY NAMELINK_SKIP)

=== plasma/CMakeLists.txt ===
add_subdirectory(dataengine)
add_subdirectory(applet)

=== plugins/CMakeLists.txt ===
MACRO (MACRO_KT_PLUGIN _option _name _dir)
option(${_option} "Whether to build the ${_name} plugin or not" true)
if (${_option})
  message(STATUS "Building ${_name} plugin (-D${_option}=false to disable)")
  add_subdirectory(${_dir})
else (${_option})
  message(STATUS "Not building ${_name} plugin (-D${_option}=true to enable)")
endif (${_option})
ENDMACRO (MACRO_KT_PLUGIN)

macro_kt_plugin(ENABLE_LOGVIEWER_PLUGIN logviewer logviewer)
macro_kt_plugin(ENABLE_INFOWIDGET_PLUGIN infowidget infowidget)
if (HAVE_KF5Completion)
    macro_kt_plugin(ENABLE_UPNP_PLUGIN upnp upnp)
endif()
if (HAVE_Qt5WebEngineWidgets)
  macro_kt_plugin(ENABLE_SEARCH_PLUGIN search search)
endif()
#macro_kt_plugin(ENABLE_WEBINTERFACE_PLUGIN webinterface webinterface)
macro_kt_plugin(ENABLE_SCANFOLDER_PLUGIN scanfolder scanfolder)
if(HAVE_QT5_Test)
  set(HAVE_QT5_Test2 1)
endif()
if (HAVE_KF5TextWidgets)
    macro_kt_plugin(ENABLE_IPFILTER_PLUGIN ipfilter ipfilter)
endif()
if (HAVE_KF5Plotting)
    macro_kt_plugin(ENABLE_STATS_PLUGIN stats stats)
endif()
macro_kt_plugin(ENABLE_BWSCHEDULER_PLUGIN bwscheduler bwscheduler)
if (HAVE_Taglib AND PHONON_FOUND_EXPERIMENTAL) #AND Qt5Multimedia_FOUND)
  macro_kt_plugin(ENABLE_MEDIAPLAYER_PLUGIN mediaplayer mediaplayer)
endif()
if (HAVE_KF5Archive AND HAVE_KF5ItemViews AND HAVE_KF5Kross)
  macro_kt_plugin(ENABLE_SCRIPTING_PLUGIN scripting scripting)
endif()
if (HAVE_KF5Syndication AND HAVE_Qt5WebEngineWidgets)
  macro_kt_plugin(ENABLE_SYNDICATION_PLUGIN syndication syndication)
endif()
macro_kt_plugin(ENABLE_DOWNLOADORDER_PLUGIN downloadorder downloadorder)
if (HAVE_LibKWorkspace)
  macro_kt_plugin(ENABLE_SHUTDOWN_PLUGIN shutdown shutdown)
endif()
if (HAVE_KF5DNSSD)
  macro_kt_plugin(ENABLE_ZEROCONF_PLUGIN zeroconf zeroconf)
endif()
macro_kt_plugin(ENABLE_MAGNETGENERATOR_PLUGIN magnetgenerator magnetgenerator)

=== plugins/logviewer/CMakeLists.txt ===
set(ktlogviewerplugin_SRC logviewerplugin.cpp logflags.cpp logviewer.cpp logprefpage.cpp logflagsdelegate.cpp)

ki18n_wrap_ui(ktlogviewerplugin_SRC logprefwidget.ui)
kconfig_add_kcfg_files(ktlogviewerplugin_SRC logviewerpluginsettings.kcfgc)
add_library(ktorrent_logviewer MODULE ${ktlogviewerplugin_SRC})

kcoreaddons_desktop_to_json(ktorrent_logviewer ktorrent_logviewer.desktop)

target_link_libraries(
    ktorrent_logviewer
    ktcore
    KF5::Torrent
    KF5::ConfigCore
    KF5::I18n
    KF5::XmlGui
)
install(TARGETS ktorrent_logviewer DESTINATION ${KTORRENT_PLUGIN_INSTALL_DIR} )

=== plugins/magnetgenerator/CMakeLists.txt ===
set(ktmagnetgeneratorplugin_SRC 
	magnetgeneratorprefwidget.cpp
	magnetgeneratorplugin.cpp)

ki18n_wrap_ui(ktmagnetgeneratorplugin_SRC magnetgeneratorprefwidget.ui)
kconfig_add_kcfg_files(ktmagnetgeneratorplugin_SRC magnetgeneratorpluginsettings.kcfgc)
add_library(ktorrent_magnetgenerator MODULE ${ktmagnetgeneratorplugin_SRC})

kcoreaddons_desktop_to_json(ktorrent_magnetgenerator ktorrent_magnetgenerator.desktop)

target_link_libraries(
    ktorrent_magnetgenerator
    ktcore
    KF5::Torrent
    KF5::CoreAddons
    KF5::I18n
    KF5::Notifications
    KF5::XmlGui
)

target_include_directories(ktorrent_magnetgenerator PRIVATE "$<BUILD_INTERFACE:${KTORRENT_SOURCE_DIR}>")

install(TARGETS ktorrent_magnetgenerator  DESTINATION ${KTORRENT_PLUGIN_INSTALL_DIR} )
install(FILES ktorrent_magnetgeneratorui.rc DESTINATION ${KXMLGUI_INSTALL_DIR}/ktorrent )

=== plugins/mediaplayer/CMakeLists.txt ===
find_package(Taglib REQUIRED)
include_directories(${TAGLIB_INCLUDES})
#find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED Multimedia MultimediaWidgets)
#include_directories(${Qt5Multimedia_INCLUDE_DIRS})
include_directories(${PHONON_INCLUDES})

set(ktmediaplayerplugin_SRC
	mediacontroller.cpp
	playlist.cpp
	playlistwidget.cpp
	mediaplayeractivity.cpp
	mediaplayerplugin.cpp
	mediaview.cpp
	mediamodel.cpp
	mediafile.cpp
	mediafilestream.cpp
	mediaplayer.cpp
	videowidget.cpp
	videochunkbar.cpp
)

set(screensaver_xml ${KTORRENT_DBUS_XML_DIR}/org.freedesktop.ScreenSaver.xml)
qt5_add_dbus_interface(ktmediaplayerplugin_SRC ${screensaver_xml} screensaver_interface)

set(powermanagementinhibit_xml ${KTORRENT_DBUS_XML_DIR}/org.freedesktop.PowerManagement.Inhibit.xml)
qt5_add_dbus_interface(ktmediaplayerplugin_SRC ${powermanagementinhibit_xml} powermanagementinhibit_interface)

ki18n_wrap_ui(ktmediaplayerplugin_SRC mediacontroller.ui)
kconfig_add_kcfg_files(ktmediaplayerplugin_SRC mediaplayerpluginsettings.kcfgc)
add_library(ktorrent_mediaplayer MODULE ${ktmediaplayerplugin_SRC})

kcoreaddons_desktop_to_json(ktorrent_mediaplayer ktorrent_mediaplayer.desktop)

target_link_libraries(
    ktorrent_mediaplayer
    ktcore
    ${TAGLIB_LIBRARIES}
    Phonon::phonon4qt5
    KF5::Torrent
    KF5::I18n
    KF5::KIOFileWidgets
    KF5::XmlGui
    KF5::WidgetsAddons
#    Qt5::MultimediaWidgets
    )
install(TARGETS ktorrent_mediaplayer DESTINATION ${KTORRENT_PLUGIN_INSTALL_DIR} )
install(FILES ktorrent_mediaplayerui.rc DESTINATION ${KXMLGUI_INSTALL_DIR}/ktorrent )

=== plugins/scripting/CMakeLists.txt ===
add_subdirectory(scripts)

set(ktscriptingplugin_SRC
	api/scriptingmodule.cpp
	api/scriptablegroup.cpp
	scriptingplugin.cpp 
	scriptmanager.cpp 
	scriptmodel.cpp
	scriptdelegate.cpp 
	script.cpp)

ki18n_wrap_ui(ktscriptingplugin_SRC scriptproperties.ui)

add_library(ktorrent_scripting MODULE ${ktscriptingplugin_SRC})

kcoreaddons_desktop_to_json(ktorrent_scripting ktorrent_scripting.desktop)

target_link_libraries(
    ktorrent_scripting
    ktcore
    Qt5::Core
    KF5::Torrent
    KF5::Archive
    KF5::ConfigCore
    KF5::CoreAddons
    KF5::I18n
    KF5::IconThemes
    KF5::ItemViews
    KF5::KIOWidgets
    KF5::KrossCore
    KF5::XmlGui
)

install(TARGETS ktorrent_scripting  DESTINATION ${KTORRENT_PLUGIN_INSTALL_DIR} )
install(FILES ktorrent_scriptingui.rc DESTINATION ${KXMLGUI_INSTALL_DIR}/ktorrent )

=== plugins/search/CMakeLists.txt ===
set(ktsearchplugin_SRC 
	webview.cpp 
	searchenginelist.cpp 
	searchprefpage.cpp 
	searchwidget.cpp 
	searchtoolbar.cpp 
	searchplugin.cpp 
	searchengine.cpp 
	opensearchdownloadjob.cpp
        searchactivity.cpp
        proxy_helper.cpp
        magneturlschemehandler.cpp)

ki18n_wrap_ui(ktsearchplugin_SRC searchpref.ui)
kconfig_add_kcfg_files(ktsearchplugin_SRC searchpluginsettings.kcfgc)
add_library(ktorrent_search MODULE ${ktsearchplugin_SRC})

kcoreaddons_desktop_to_json(ktorrent_search ktorrent_search.desktop)

target_link_libraries(
    ktorrent_search
    ktcore
    Qt5::WebEngineWidgets
    KF5::Torrent
    KF5::CoreAddons
    KF5::Completion
    KF5::ConfigCore
    KF5::ConfigGui
    KF5::I18n
    KF5::IconThemes
    KF5::KIOCore
    KF5::KIOWidgets
    KF5::Notifications
    KF5::WidgetsAddons
    KF5::XmlGui
)

install(TARGETS ktorrent_search  DESTINATION ${KTORRENT_PLUGIN_INSTALL_DIR} )
install(FILES ktorrent_searchui.rc DESTINATION ${KXMLGUI_INSTALL_DIR}/ktorrent )

add_subdirectory(opensearch)
add_subdirectory(home)

=== plugins/stats/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/drawer)

set(Drawer_SRC
	drawer/ChartDrawer.cc
	drawer/ChartDrawerData.cc
	drawer/ChartDrawerData.h
	drawer/ChartDrawer.h
	drawer/PlainChartDrawer.cc
	drawer/PlainChartDrawer.h
	drawer/KPlotWgtDrawer.cc
	drawer/KPlotWgtDrawer.h
)

set(ktstatsplugin_SRC 
	${Drawer_SRC} 
	StatsPlugin.cc 
	PluginPage.cc 
	SpdTabPage.cc 
	ConnsTabPage.cc
	SettingsPage.cc
	DisplaySettingsPage.cc
)

ki18n_wrap_ui(ktstatsplugin_SRC Spd.ui Conns.ui Settings.ui DisplaySettings.ui)
kconfig_add_kcfg_files(ktstatsplugin_SRC statspluginsettings.kcfgc)
add_library(ktorrent_stats MODULE ${ktstatsplugin_SRC})
kcoreaddons_desktop_to_json(ktorrent_stats ktorrent_stats.desktop)

target_link_libraries(
    ktorrent_stats
    ktcore
    KF5::Torrent
    KF5::CoreAddons
    KF5::I18n
    KF5::Plotting
    KF5::WidgetsAddons
)
install(TARGETS ktorrent_stats  DESTINATION ${KTORRENT_PLUGIN_INSTALL_DIR} )

=== debian/changelog ===
ktorrent (5.2.0-2) unstable; urgency=medium

  * Team upload.
  * Backport upstream commit f4c1c91d9b091941ebb4dae6aef95bcf9bc1c388 to fix
    the cmake search and use of taglib; patch
    upstream_Update-FindTaglib-from-ECM.patch (Closes: #973223)
  * Fix day-of-week for changelog entry 1.1-1.
  * Set upstream metadata fields: Repository, Repository-Browse.
  * Add the configuration for the CI on salsa.
  * Explicitly add the pkg-config build dependency.

 -- Pino Toscano <pino@debian.org>  Sat, 07 Nov 2020 10:52:19 +0100

ktorrent (5.2.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release:
    - disables the logging by default (Closes: #875898)
  * Drop the Debian man pages, as they are outdated, and they offer no useful
    information.
  * Update the build dependencies according to the upstream build system:
    - bump libktorrent to 2.2.0
    - add qtwebengine5-dev (only where available)
    - remove libkf5webkit-dev, no more used
    - explicitly add gettext
  * Bump the debhelper compatibility to 13:
    - switch the debhelper build dependency to debhelper-compat 13
    - remove debian/compat
    - stop passing --fail-missing to dh_missing, as it is the default now
  * Add Rules-Requires-Root: no.
  * Bump Standards-Version to 4.5.0, no changes required.
  * Update install files.

 -- Pino Toscano <pino@debian.org>  Fri, 07 Aug 2020 17:03:36 +0200

=== debian/control ===
Source: ktorrent
Section: net
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Modestas Vainius <modax@debian.org>
Build-Depends: cmake (>= 2.8.12), debhelper-compat (= 13), pkg-kde-tools (>= 0.15.16),
 gettext,
 pkg-config,
 extra-cmake-modules,
 qtbase5-dev (>= 5.7.0),
 qtscript5-dev (>= 5.7.0),
 qtwebengine5-dev (>= 5.7.0) [amd64 arm64 armhf i386 mipsel],
 libphonon4qt5-dev, libphonon4qt5experimental-dev,
 libkf5archive-dev (>= 5.15),
 libkf5completion-dev (>= 5.15),
 libkf5config-dev (>= 5.15),
 libkf5configwidgets-dev (>= 5.15),
 libkf5coreaddons-dev (>= 5.15),
 libkf5crash-dev (>= 5.15),
 libkf5dbusaddons-dev (>= 5.15),
 libkf5dnssd-dev (>= 5.15),
 libkf5doctools-dev (>= 5.15),
 libkf5i18n-dev (>= 5.15),
 libkf5iconthemes-dev (>= 5.15),
 libkf5kio-dev (>= 5.15),
 libkf5itemviews-dev (>= 5.15),
 libkf5notifications-dev (>= 5.15),
 libkf5notifyconfig-dev (>= 5.15),
 libkf5kcmutils-dev (>= 5.15),
 libkf5parts-dev (>= 5.15),
 libkf5plotting-dev (>= 5.15),
 libkf5solid-dev (>= 5.15),
 libkf5textwidgets-dev (>= 5.15),
 libkf5widgetsaddons-dev (>= 5.15),
 libkf5windowsystem-dev (>= 5.15),
 libkf5xmlgui-dev (>= 5.15),
 kross-dev (>= 5.15),
 libkf5syndication-dev,
 libboost-dev,
 libktorrent-dev (>= 2.2.0~), libtag1-dev, libgeoip-dev,
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://www.kde.org/applications/internet/ktorrent/
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/ktorrent.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/ktorrent

Package: ktorrent
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ktorrent-data (= ${source:Version}),
 libktorrent-l10n
Suggests: krosspython, geoip-database
Description: BitTorrent client based on the KDE platform
 This package contains KTorrent, a BitTorrent peer-to-peer network client, that
 is based on the KDE platform. Obviously, KTorrent supports such basic features
 as downloading, uploading and seeding files on the BitTorrent network.
 However, lots of other additional features and intuitive GUI should make
 KTorrent a good choice for everyone. Some features are available as plugins
 hence you should make sure you have the ones you need enabled.
   - Support for HTTP and UDP trackers, trackerless DHT (mainline) and webseeds.
   - Alternative UI support including Web interface.
   - Torrent grouping, speed capping, various download prioritization
     capabilities on both torrent and file level as well as bandwidth
     scheduling.
   - Support for fetching torrent files from many sources including any local
     file or remote URL, RSS feeds (with filtering) or actively monitored
     directory etc.
   - Integrated and customizable torrent search on the Web.
   - Various security features like IP blocking and protocol encryption.
   - Disk space preallocation to reduce fragmentation.
   - uTorrent compatible peer exchange.
   - Autoconfiguration for LANs like Zeroconf extension and port forwarding via
     uPnP.
   - Scripting support via Kross and interprocess control via DBus interface.
   - SOCKSv4 and SOCKSv5 proxy, IPv6 support.
   - Lots of other useful built-in features and plugins.

Package: ktorrent-data
Architecture: all
Depends: ${misc:Depends}
Recommends: ktorrent (>= ${source:Version})
Description: KTorrent data and other architecture independent files
 This package contains architecture independent data files for KTorrent,
 a BitTorrent peer-to-peer network client. Unless you have ktorrent package
 installed, you probably won't find this package useful.

## ktorrent 20.12.3

=== debian/changelog ===
ktorrent (20.12.3-0ubuntu1) hirsute; urgency=medium

  * New upstream release (20.12.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 04 Mar 2021 15:26:18 +0000

ktorrent (20.12.2-0ubuntu1) hirsute; urgency=medium

  * New upstream release (20.12.2)

 -- Rik Mills <rikmills@kde.org>  Thu, 04 Feb 2021 09:59:33 +0000

ktorrent (20.12.1-0ubuntu1) hirsute; urgency=medium

  * New upstream release (20.12.1)

 -- Rik Mills <rikmills@kde.org>  Wed, 20 Jan 2021 23:13:31 +0000

ktorrent (20.12.0-0ubuntu1) hirsute; urgency=medium

  * New upstream release (20.12.0)
  * Drop included upstream_Update-FindTaglib-from-ECM.patch

 -- Rik Mills <rikmills@kde.org>  Fri, 11 Dec 2020 14:32:47 +0000

=== debian/control ===
--- 
+++ 
@@ -3,41 +3,46 @@
 Priority: optional
 Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
 Uploaders: Modestas Vainius <modax@debian.org>
-Build-Depends: cmake (>= 2.8.12), debhelper-compat (= 13), pkg-kde-tools (>= 0.15.16),
- gettext,
- pkg-config,
- extra-cmake-modules,
- qtbase5-dev (>= 5.7.0),
- qtscript5-dev (>= 5.7.0),
- qtwebengine5-dev (>= 5.7.0) [amd64 arm64 armhf i386 mipsel],
- libphonon4qt5-dev, libphonon4qt5experimental-dev,
- libkf5archive-dev (>= 5.15),
- libkf5completion-dev (>= 5.15),
- libkf5config-dev (>= 5.15),
- libkf5configwidgets-dev (>= 5.15),
- libkf5coreaddons-dev (>= 5.15),
- libkf5crash-dev (>= 5.15),
- libkf5dbusaddons-dev (>= 5.15),
- libkf5dnssd-dev (>= 5.15),
- libkf5doctools-dev (>= 5.15),
- libkf5i18n-dev (>= 5.15),
- libkf5iconthemes-dev (>= 5.15),
- libkf5kio-dev (>= 5.15),
- libkf5itemviews-dev (>= 5.15),
- libkf5notifications-dev (>= 5.15),
- libkf5notifyconfig-dev (>= 5.15),
- libkf5kcmutils-dev (>= 5.15),
- libkf5parts-dev (>= 5.15),
- libkf5plotting-dev (>= 5.15),
- libkf5solid-dev (>= 5.15),
- libkf5textwidgets-dev (>= 5.15),
- libkf5widgetsaddons-dev (>= 5.15),
- libkf5windowsystem-dev (>= 5.15),
- libkf5xmlgui-dev (>= 5.15),
- kross-dev (>= 5.15),
- libkf5syndication-dev,
- libboost-dev,
- libktorrent-dev (>= 2.2.0~), libtag1-dev, libgeoip-dev,
+Build-Depends: cmake (>= 2.8.12),
+               debhelper-compat (= 13),
+               extra-cmake-modules,
+               gettext,
+               kross-dev (>= 5.15),
+               libboost-dev,
+               libgeoip-dev,
+               libkf5archive-dev (>= 5.15),
+               libkf5completion-dev (>= 5.15),
+               libkf5config-dev (>= 5.15),
+               libkf5configwidgets-dev (>= 5.15),
+               libkf5coreaddons-dev (>= 5.15),
+               libkf5crash-dev (>= 5.15),
+               libkf5dbusaddons-dev (>= 5.15),
+               libkf5dnssd-dev (>= 5.15),
+               libkf5doctools-dev (>= 5.15),
+               libkf5i18n-dev (>= 5.15),
+               libkf5iconthemes-dev (>= 5.15),
+               libkf5itemviews-dev (>= 5.15),
+               libkf5kcmutils-dev (>= 5.15),
+               libkf5kio-dev (>= 5.15),
+               libkf5notifications-dev (>= 5.15),
+               libkf5notifyconfig-dev (>= 5.15),
+               libkf5parts-dev (>= 5.15),
+               libkf5plotting-dev (>= 5.15),
+               libkf5solid-dev (>= 5.15),
+               libkf5syndication-dev,
+               libkf5textwidgets-dev (>= 5.15),
+               libkf5widgetsaddons-dev (>= 5.15),
+               libkf5windowsystem-dev (>= 5.15),
+               libkf5xmlgui-dev (>= 5.15),
+               libktorrent-dev (>= 20.12.3~),
+               libphonon4qt5-dev,
+               libphonon4qt5experimental-dev,
+               libtag1-dev,
+               pkg-config,
+               pkg-kde-tools (>= 0.15.16),
+               qtbase5-dev (>= 5.7.0),
+               qtscript5-dev (>= 5.7.0),
+               qtwebengine5-dev (>= 5.7.0) [amd64 arm64 armhf i386 mipsel],
 Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Homepage: https://www.kde.org/applications/internet/ktorrent/

## ktorrent 21.08.1

=== debian/changelog ===
ktorrent (21.08.1-0ubuntu1) impish; urgency=medium

  * New upstream release (21.08.1)

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Thu, 09 Sep 2021 22:38:23 +0100

ktorrent (21.08.0-0ubuntu1) impish; urgency=medium

  * New upstream release (21.08.0)

 -- Rik Mills <rikmills@kde.org>  Thu, 12 Aug 2021 09:07:45 +0100

ktorrent (21.07.90-0ubuntu1) impish; urgency=medium

  * New upstream (RC) release (21.07.90)

 -- Rik Mills <rikmills@kde.org>  Mon, 02 Aug 2021 13:01:51 +0100

ktorrent (21.07.80-0ubuntu1) impish; urgency=medium

  * New upstream (beta) release (21.07.80)

 -- Rik Mills <rikmills@kde.org>  Sat, 17 Jul 2021 19:21:03 +0100

ktorrent (21.04.3-0ubuntu1) impish; urgency=medium

  * New upstream release (21.04.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 08 Jul 2021 11:48:57 +0100

ktorrent (21.04.2-0ubuntu1) impish; urgency=medium

  * New upstream release (21.04.2)

 -- Rik Mills <rikmills@kde.org>  Thu, 10 Jun 2021 10:46:08 +0100

ktorrent (21.04.1-0ubuntu1) impish; urgency=medium

  * New upstream release (21.04.1)

 -- Rik Mills <rikmills@kde.org>  Thu, 13 May 2021 09:12:34 +0100

ktorrent (21.04.0-0ubuntu1) impish; urgency=medium

  * New upstream release (21.04.0)

 -- Rik Mills <rikmills@kde.org>  Thu, 29 Apr 2021 01:42:49 +0100

=== debian/control ===
--- 
+++ 
@@ -34,7 +34,7 @@
                libkf5widgetsaddons-dev (>= 5.15),
                libkf5windowsystem-dev (>= 5.15),
                libkf5xmlgui-dev (>= 5.15),
-               libktorrent-dev (>= 20.12.3~),
+               libktorrent-dev (>= 21.08.1~),
                libphonon4qt5-dev,
                libphonon4qt5experimental-dev,
                libtag1-dev,
